#include <sys/stat.h>	// fuer struct stat
#include <unistd.h>	// fuer stat(.)
#include <time.h>	// fuer ctime(.)
#include <stdlib.h>	// fuer exit(.)
#include <stdio.h>

int main(int argc, char **argv) {
    int i; char *s; 
    struct stat statbuf;
    for (i = 1; i < argc; i++) {
	printf("Datei \"%s\":\n", argv[i]);
	
	if (stat(argv[i], &statbuf) < 0)
	    perror("stat"), exit(1);	// Abbruch im Fehlerfall
	
	/* ctime(.) erzeugt aus der Datenstruktur time_t einen String */
	printf("	letzter Zugriff: %s",
		ctime(&statbuf.st_atime));
	/* statbuf.st_mtime und statbuf.st_ctime
	 * koennen analog behandelt werden. */

	switch (statbuf.st_mode & S_IFMT) {
	    case S_IFREG  : s = "normale Datei"; break;
	    case S_IFDIR  : s = "Verzeichnis"; break;
	    case S_IFCHR  : s = "zeichenorient. Geraet"; break;
	    case S_IFBLK  : s = "blockorient. Geraet"; break;
	    case S_IFLNK  : s = "symbolischer Link"; break;
	    case S_IFIFO  : s = "FIFO"; break;
	    case S_IFSOCK : s = "Socket"; break;
	    default:	    s = "_unbekannt_"; break;
	}
	printf("	Datei-Typ: %s\n", s);

        /* Rechte: */
        printf("Rechte: %o\n", statbuf.st_mode & 0777);

        /*sticky-Bit?*/
        printf("sticky-Bit ist %sgesetzt!\n",
              (statbuf.st_mode & 01000) ? "" : "nicht ");
        /*setgid-Bit?*/
        printf("setgid-Bit ist %sgesetzt!\n",
              (statbuf.st_mode & 02000) ? "" : "nicht ");
        /*setuid-Bit?*/
        printf("setuid-Bit ist %sgesetzt!\n",
              (statbuf.st_mode & 04000) ? "" : "nicht ");

	/* Bsp.: Darf Eigentmer lesen? */
        printf("r-Bit des Eigentmers ist %sgesetzt!\n",
              (statbuf.st_mode & 0100) ? "" : "nicht ");
       
    }
    return 0;
}
